package fib;

/**
 *
 * @author Bright
 * Version 2
 * Update date: March 20, 2017
 */

import java.io.*;
import java.util.Scanner;
import java.util.InputMismatchException;

class Fib
{
 	public int Fibonacci(int n)
	{  
		if ( n == 0 || n == 1)  // 第0項與第1項為 1
			return 1;
 		else
			return( Fibonacci(n-1) + Fibonacci(n-2) );
	}

	public static void main (String args[])  // 主函數		 
	{
		Scanner keyboard = new Scanner(System.in);
		Fib obj= new Fib();
		String ch="";
		int n=0;

		System.out.print("-----Fibonaci numbers Using Recursive-----");
		do {
			System.out.print("\nEnter a number(n>=0) : ");
			try {
				n = keyboard.nextInt();
			} catch(InputMismatchException e) {
				keyboard.nextLine();
				System.out.printf("Not a correctly number.\n");
				System.out.printf("Try again\n\n");
			} 
				
			// n值大於0
			if (n < 0)
				System.out.printf("Number must be > 0\n\n");
			else
				System.out.println("Fibonacci(" + n + ") = " + obj.Fibonacci(n) + "\n"); 
			System.out.print("Contiune (y/n) ? ");
            ch = keyboard.next();
		} while (ch.equals("y"));
	}
}
