package heapsort;

/**
 *
 * @author Bright
 * Version 3
 * Update date: March 23, 2017
 */

import java.io.*;
class HeapSort
{
	int temp;
 	public void heap_sort(int data[])
	{
 		int i, j, k;   

		System.out.print("\n<< Heap sort >>\n");
		System.out.print("Number : ");
		for (k = 1; k <= 10; k++)
			System.out.printf("%2d  ", data[k]);
		System.out.print("\n");
		for (k = 0; k < 60; k++)
			System.out.print("-");
		for (i = 10/2; i > 0; i--)
			adjust(data, i, 10);
		System.out.print("\nHeap    : ");
		for (k = 1; k <= 10; k++)
			System.out.printf("%2d  ", data[k]);
		for (i = 9; i > 0; i--) {
			temp = data[i+1];
			data[i+1] = data[1];
			data[1] = temp;           // 將樹根和最後的節點交換
			adjust(data, 1, i);      // 再重新調整為堆積樹
			System.out.print("\nSorting : ");
			for (k = 1; k <= 10; k++)
				System.out.printf("%2d  ", data[k]); 
		}
		System.out.print("\n");
		for (k = 0; k < 60; k++)
			System.out.print("-");
		System.out.print("\nFinal sorted data: ");
		for (k = 1; k <= 10; k++)
			System.out.print(data[k] + "  ");
                System.out.print("\n");

	}
   
	public void adjust(int data[], int i, int n)  // 將資料調整為堆積樹 
	{
		int j, k, done = 0;
		k = data[i];
		j = 2*i;
		while ((j <= n) && (done == 0)) {
			if ((j < n) && (data[j] < data[j+1])) 
				j++;
			if (k >= data[j]) 
				done = 1;
			else {
				data[j/2] = data[j];
				j *= 2;
			}
		}
		data[j/2] = k;
	}
   
	public static void main (String args[])
	{
		HeapSort obj = new HeapSort();
		int[] data = {0, 27, 7, 80, 5, 67, 18, 62, 24, 58, 25};
		obj.heap_sort(data);
	}
}
