package matrix;

/**
 *
 * @author Bright
 * Version 2
 * Update date: March 18, 2017
 */

import java.io.*;

public class Matrix
{
	static int N = 3;
	static int[][] C = new int [N][N];
	static int sum=0;
	
 	public static void access_matrix(int A[][], int B[][])
	{ 
		int i=0, j=0, k=0;

		// 將A矩陣每一列元素與B矩陣每一列元素
		// 相乘之和放入C矩陣之中
		for ( i = 0 ; i < N ; i++ )
			for ( j = 0 ; j < N ; j++ ) {
				sum = 0 ;
				for ( k = 0 ; k < N ; k++ )
					sum = sum + A[i][k] * B[k][j] ;
				C[i][j] = sum ;
			}
	}

	public static void output_result(int A[][], int B[][])
	{
		// 列出三矩陣內容
		System.out.print("\nContent of Matrix A :\n\n");
		output_Matrix(A) ;
		System.out.print("\nContent of Matrix B :\n\n");
		output_Matrix(B) ;
		System.out.print("\nContent of Matrix C :\n\n");
		output_Matrix(C) ;
	}

	public static void output_Matrix(int m[][])
	{
		int i=0, j=0 ;

		for ( i = 0 ; i < N ; i++ ) {
		     for ( j = 0 ; j < N ; j++ ) 
		     System.out.printf("%4d", m[i][j]) ;	
		     System.out.print("\n") ;
		}
	}

	public static void main (String args[])  // 主函數		 
	{
		Matrix obj = new Matrix();
		int[][]  A = new int[N][N];
		int[][]  B = new int[N][N];

		A[0][0]=1; A[0][1]=2; A[0][2]=3; 
		A[1][0]=4; A[1][1]=5; A[1][2]=6; 
		A[2][0]=7; A[2][1]=8; A[2][2]=9; 
 
		B[0][0]=1; B[0][1]=2; B[0][2]=3; 
		B[1][0]=1; B[1][1]=2; B[1][2]=3; 
		B[2][0]=1; B[2][1]=2; B[2][2]=3; 

		obj.access_matrix(A, B);
		obj.output_result(A, B);	  
	}
}
