package factor;

/**
 *
 * @author Bright
 * Version 2
 * Update date: March 20, 2017
 */

import java.io.*;
import java.util.Scanner;
import java.util.InputMismatchException;

class Factor 
{
 
	public int Factorial(int n)
	{
		if (n == 1)
			return (1);
		else
			return(n * Factorial(n-1));
	}

	public static void main (String args[])  //主函數		 
	{
		Scanner keyboard = new Scanner(System.in);
		Factor obj = new Factor();
		String ch = "";
		int n=0;

		System.out.print("-----Factorial counting Using Recursive----");
		do {
			System.out.print("\nEnter a number( 0<=n<=12 ) to count n!: ");
			
 	 	    try {
				n = keyboard.nextInt();
			} catch(InputMismatchException e) {
				keyboard.nextLine();
				System.out.printf("Not a correctly number.\n");
				System.out.printf("Try again\n\n");
			}
			
			// n 值在一般系統中超過13會產生overflow 得到不正確的值
			if ( n < 0 || n >12 )
				System.out.println("input out of range !\n");
			else
				System.out.println(n + "! = " + obj.Factorial(n) + "\n");

			System.out.print("Continue (y/n) ? ");
 		    ch = keyboard.next();
 		} while (ch.equals("y")) ;
 	}
}
