package binarytreesort;

/**
 *
 * @author Bright
 * Version 3
 * Update date: March 23, 2017
 */

import java.io.*;

class Node_type 
{ 
	public int num;
	public Node_type lbaby, rbaby;
}

class BinaryTreeSort
{
	Node_type root, tree, leaf;
 
	public void binary_sort(int data[])
	{ 
 		String st="";
		int i=0;     

		System.out.print("\n<<Binary Tree Sort>> \n");
		System.out.print("Number : ");
		for (i = 0; i < 10; i++)
			System.out.printf("%4d ", data[i]);
		System.out.print("\n");
		for (i = 0; i < 60; i++)   
			System.out.print("-");
		root = new Node_type();
		root.num = data[0];  // 建立樹根
		root.lbaby = null;
		root.rbaby = null;
		System.out.print("\nSorting: ");
		output(root);
		leaf = new Node_type();         
		for (i = 1; i < 10; i++) { // 建立樹枝 
			leaf.num = data[i];
			leaf.lbaby = null;
			leaf.rbaby = null;
			find(leaf.num, root);  
			if (leaf.num > tree.num)  // 若比父節點大，則放在右子樹
				tree.rbaby = leaf;
			else                      // 否則放在左子樹
				tree.lbaby = leaf;
			System.out.print("\nSorting: ");
			output(root);
			leaf = new Node_type();
		}
		System.out.print("\n");
		for (i = 0; i < 60; i++)   
			System.out.print("-");
		System.out.print("\nFinal sorted data: ");
		output(root);
                System.out.print("\n");
	}

	public void find(int input, Node_type papa)
	{
		if ((input > papa.num) && (papa.rbaby != null))
			find (input, papa.rbaby);
		else
			if ((input < papa.num) && (papa.lbaby != null))
				find (input, papa.lbaby);
			else
				tree = papa;
	}

	// 印出資料
	public void output(Node_type node) // 用中序追蹤將資料印出
	{
		if (node != null) {
			output(node.lbaby);
			System.out.printf("%4d ", node.num);
			output(node.rbaby);
		}
	}
	public static void main(String args[])
	{
		BinaryTreeSort obj = new BinaryTreeSort();
		int[] data = {18, 2, 20, 34, 12, 32, 6, 16, 25, 10};

		obj.binary_sort(data);  
 	}
} 
