package radixsort;

/**
 *
 * @author Bright
 * Version 3
 * Update date: March 23, 2017
 */

import java.io.*;

class RadixSort 
{
 	public void radix_sort(int data[], int order[])
	{
		int i, j, k = 0, n = 1, lsd;
		int[][] temp = new int[10][10];
		
		while(n <= 100) {
			for (i = 0; i < 10; i++) {
				lsd = ((data[i]/n) % 10);
				temp[lsd][order[lsd]] = data[i];  // 依餘數將資料分類
				order[lsd]++;
			}
			System.out.print("\nSorting: ");
			for (i = 0; i < 10; i++) {
				if (order[i] != 0)
					for (j = 0; j < order[i]; j++) {
						// 依分類後的順序將資料重新排列
						data[k] = temp[i][j];
						System.out.printf("%5d ", data[k]);
						k++;
					}
				order[i] = 0;
			}
			n *= 10;
			k = 0;
		}
	}

	public static void main(String args[])
	{
		RadixSort obj = new RadixSort();
		int[] data = {199, 228, 326, 118, 879, 882, 76, 32, 291, 56};
		int[] order = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
		int i;
      
		System.out.printf("\n<< Radix sort >>\n");
		System.out.printf("\nNumber : ");
		for (i = 0; i < 10; i++)
			System.out.printf("%5d ", data[i]);
		System.out.println("");
		for (i = 0; i < 70; i++)
			System.out.printf("-");
		obj.radix_sort(data, order);
		System.out.println("");
		for (i = 0; i < 70; i++)
			System.out.printf("-");
		System.out.print("\nFinalsorted data:\n");
		for (i = 0; i < 10; i++)
			System.out.printf("%5d ", data[i]);
		System.out.printf("\n");
	}
} 
