package shellsort;

/**
 *
 * @author Bright
 * Version 3
 * Update date: March 23, 2017
 */

import java.io.*;
class ShellSort
{
	final static int MAX = 9;
	int temp=0;
 
	public void shell_sort(int data[])
	{
		int i=0, j=0, k=0, incr=0;
  	
		incr = MAX/2;
		while (incr > 0) {
			for (i = incr+1; i <= MAX; i++) {
				j = i - incr;
				while (j > 0)
				   if (data[j] > data[j+incr]) { // 比較每部份的資料
					    // 大小順序不對則交換
					    temp = data[j];
					    data[j] = data[j+incr];
					    data[j+incr] = temp;
					    j = j - incr;
				   } else 
					   j=0;
			}
			System.out.print("\nSorting: ");
			for (i = 1; i <= MAX; i++)
				System.out.printf("%3d ", data[i]);
			incr = incr/2;
		}
	}

	public static void main (String args[])
	{
		ShellSort obj = new ShellSort();
		int[] data = {0, 39, 11, 48, 5, 77, 18, 70, 25, 55};
		int i, k;
		
		System.out.printf("\n<< Shell sort >>\n");
		System.out.printf("Number : ");
		for (i = 1; i < 10; i++)
			System.out.printf("%3d ", data[i]);
		System.out.print("\n");
		for (k = 0; k < 60; k++)
		System.out.print("-");
		obj.shell_sort(data);  
		System.out.print("\n");
		for (k = 0; k < 60; k++)
			System.out.print("-");
		System.out.printf("\nFinal sorted data: ");
		for (i = 1; i <= MAX; i++)
			System.out.printf("%3d ", data[i]);
      System.out.print("\n");                
	}
}
